<?php

$wgExtensionCredits['parserhook'][] = array(
	'path'            => __FILE__,
	'name'            => 'GetSTWSynonyms',
	'version'         => '0.0.1',
	'descriptionmsg'  => 'stringfunctions-desc',
	'author'          => 'MF',
	'url'             => 'http://google.de?q=getSTWSynonyms',
);

$dir = dirname( __FILE__ ) . '/';
#$wgExtensionMessagesFiles['Quark'] = $dir . 'Quark.i18n.php';

$wgExtensionFunctions[] = 'wfGetSTWSynonyms';


## include js and css (new version) ##
$wgResourceModules['ext.expandcollapsed'] = array(
        // JavaScript and CSS styles. To combine multiple files, just list them as an array.
        'scripts' => 'js/expandcollapsed.js',
	// 'styles' => 'css/expandcollapsed.css',
 
        // When your module is loaded, these messages will be available through mw.msg()
        'messages' =>  'myextension-unstructured-external-search',
	'dependencies' => array( 'jquery' ),
 	
        // You need to declare the base path of the file paths in 'scripts' and 'styles'
        'localBasePath' => dirname( __FILE__ ),
        // ... and the base from from the browser as well. For extensions this is made easy,
        // you can use the 'remoteExtPath' property to declare it relative to where the wiki
        // has $wgExtensionAssetsPath configured:
        'remoteExtPath' => 'expandcollapsed',
	// optional
//'position' => 'top',
);

$wgResourceModules['ext.expandcollapsedcss'] = array(
        // JavaScript and CSS styles. To combine multiple files, just list them as an array.
        'styles' => 'css/expandcollapsed.css',
 
        // When your module is loaded, these messages will be available through mw.msg()
        'messages' =>  'myextension-unstructured-external-search-css',
 
        // You need to declare the base path of the file paths in 'scripts' and 'styles'
        'localBasePath' => dirname( __FILE__ ),
        // ... and the base from from the browser as well. For extensions this is made easy,
        // you can use the 'remoteExtPath' property to declare it relative to where the wiki
        // has $wgExtensionAssetsPath configured:
        'remoteExtPath' => 'expandcollapsedcss',
	// optional
);

## include another js ##
$wgResourceModules['ext.useMarkedText'] = array(
        // JavaScript and CSS styles. To combine multiple files, just list them as an array.
        'scripts' => 'js/useMarkedText.js',
 
        // When your module is loaded, these messages will be available through mw.msg()
        'messages' =>  'myextension-unstructured-external-search...',
	'dependencies' => array( 'jquery' ),
 	
        // You need to declare the base path of the file paths in 'scripts' and 'styles'
        'localBasePath' => dirname( __FILE__ ),
        // ... and the base from from the browser as well. For extensions this is made easy,
        // you can use the 'remoteExtPath' property to declare it relative to where the wiki
        // has $wgExtensionAssetsPath configured:
        'remoteExtPath' => 'useMarkedText'
);

## ##


$wgHooks['LanguageGetMagic'][] = 'wfGetSTWSynonymsLanguageGetMagic';

function wfGetSTWSynonyms ( ) {
	global $wgParser, $wgExtGetSTWSynonyms;
	$wgExtGetSTWSynonyms = new ExtGetSTWSynonyms ( );
	$wgParser->setFunctionHook('getSTWSynonyms',      array(&$wgExtGetSTWSynonyms,'getSTWSynonyms'      ));	
}

function wfGetSTWSynonymsLanguageGetMagic( &$magicWords, $langCode = "en" ) {
	switch ( $langCode ) {
	default:
		$magicWords['getSTWSynonyms']          = array ( 0, 'getSTWSynonyms' );
	}
	return true;
}




class ExtGetSTWSynonyms {
# take care: paramters correct?
	function getSTWSynonyms ( &$parser, $querystring = '') {
		
	$querykeywords = explode(',', $querystring);
	global $wgOut;
	$output = '';
## old:
    $wgOut -> addModules('ext.expandcollapsed');
    $wgOut -> addModules('ext.expandcollapsedcss');

	foreach($querykeywords as $qkeyphrase)
	{	$output = $output . 'keyphrase:_' . $qkeyphrase . '_';
		$request = 'http://zbw.eu/beta/econ-ws/synonyms?output=sparql-json&query=' . $qkeyphrase;

		$response = file_get_contents($request);
		$jsonobj = null;
		$jsonobj = json_decode($response);
		
		$resultnr = 0;
	
		if($jsonobj != null) {
	
			//var_dump($jsonobj->{'results'}->{'bindings'}); 
			foreach($jsonobj->{'results'}->{'bindings'} as $b)
			{
				foreach($b as $v)
				{
						$output = $output . $v->{'value'} . ', ';	
						$resultnr++;	
				}
	
			}
		
			if($resultnr == 0) {
				$output .= '-';
			}
			
		}
	}

	return $output;

} // end of function














	
##################

/**
	function getSTWSynonyms2 ( &$parser, $inStr = '' ) {
$url = 'http://ajax.googleapis.com/ajax/services/search/web?rsz=large&v=1.0&q=' . urlencode('site:' . $_SERVER['HTTP_HOST'] . ' ' . $_POST['searchquery']);
return $url;
// use PHP's curl library to pull Google's search results (curl library info @ http://us.php.net/curl)

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_REFERER, $_SERVER['REQUEST_URI']);
$body = curl_exec($ch);
curl_close($ch);

// now $body is the JSON encoded results. We need to decode them. I used the JSON decoder @ http://mike.teczno.com/JSON/JSON.phps

$json = new Services_JSON();
$json = $json->decode($body);

// now $json is an object of Google's search results and we need to iterate through it.

foreach(json->responseData->results as $searchresult)
{
  if($searchresult->GsearchResultClass == 'GwebSearch')
  {
    echo '
    <div class="searchresult">
      <h3><a href="' . $searchresult->unescapedUrl . '">' . $searchresult->titleNoFormatting . '</a></h3>
      <p>' . $searchresult->content . '</p>
      <p>' . $searchresult->visibleUrl . '</p>
    </div>';
  }
}

}

**/


##########################
/**
         protected function includeJS() {
                 SMWOutputs::requireHeadItem( SMW_HEADER_STYLE );
 
                 // MediaWiki 1.17 introduces the Resource Loader.
                 $realFunction = array( 'SMWOutputs', 'requireResource' );
                 if ( defined( 'MW_SUPPORTS_RESOURCE_MODULES' ) && is_callable( $realFunction ) ) {
                         SMWOutputs::requireResource( 'ext.srf.timeline' );
                 }
                 else {
                         global $srfgScriptPath;
                         SMWOutputs::requireHeadItem(
                                 'smw_tlhelper',
                                 '<script type="text/javascript" src="' . $srfgScriptPath . 
                                         '/Timeline/SRF_timeline.js"></script>'
                         );
                         SMWOutputs::requireHeadItem(
                                 'smw_tl',
                                 '<script type="text/javascript" src="' . $srfgScriptPath . 
                                         '/Timeline/SimileTimeline/timeline-api.js"></script>'
                         );                      
                 }               
         }
	}

**/

}
